<template>
    <q-menu
        v-if="!$store.state.chat.isSelectMultiple"
        touch-position
        auto-close
        :class="[$store.state.user.isDarkMode ? 'dark' : '']"
    >
        <q-list dense class="context-menu" style="min-width: 100px">
            <!-- Sticker -->
            <!-- <q-item
                v-if="
                    message.type == MessageType.STICKER &&
                    message.flags?.deleteFlag != MessageDeleteFlag.DELETE_ALL
                "
                clickable
                v-close-popup
                @click="addToSticker"
            >
                <q-item-section>
                    <div class="row">
                        <q-icon name="mdi-sticker-circle-outline" size="sm" />
                        {{ $t('buttons.addToStickers') }}
                    </div>
                </q-item-section>
            </q-item> -->

            <!-- Select Multiple -->
            <!-- <q-item clickable v-close-popup @click="selectMultiple">
                <q-item-section>
                    <div class="row">
                        <q-icon
                            name="mdi-checkbox-multiple-marked-outline"
                            size="sm"
                        />
                        {{ $t('buttons.selectMultiple') }}
                    </div>
                </q-item-section>
            </q-item> -->

            <!-- Remove Favourite -->
            <!-- <q-item
                v-if="
                    message.flags?.favouriteFlag &&
                    message.flags?.deleteFlag != MessageDeleteFlag.DELETE_ALL
                "
                clickable
                v-close-popup
                @click="updateFavouriteFlag(0)"
            >
                <q-item-section>
                    <div class="row">
                        <q-icon name="mdi-star-off-outline" size="sm" />
                        {{ $t('buttons.removeFavourite') }}
                    </div>
                </q-item-section>
            </q-item> -->

            <!-- Favourite -->
            <!-- <q-item
                v-if="
                    !message.flags?.favouriteFlag &&
                    message.flags?.deleteFlag != MessageDeleteFlag.DELETE_ALL
                "
                clickable
                v-close-popup
                @click="updateFavouriteFlag(1)"
            >
                <q-item-section>
                    <div class="row">
                        <q-icon name="mdi-star-outline" size="sm" />
                        {{ $t('buttons.favourite') }}
                    </div>
                </q-item-section>
            </q-item> -->

            <!-- Forward -->
            <!-- <q-item
                v-if="message.flags?.deleteFlag != MessageDeleteFlag.DELETE_ALL"
                clickable
                v-close-popup
                @click="forward"
            >
                <q-item-section>
                    <div class="row">
                        <q-icon name="mdi-share-outline" size="sm" />
                        {{ $t('buttons.forward') }}
                    </div>
                </q-item-section>
            </q-item> -->

            <!-- Reply -->
            <q-item
                v-if="message.flags?.deleteFlag != MessageDeleteFlag.DELETE_ALL"
                clickable
                v-close-popup
                @click="replyTo"
            >
                <q-item-section>
                    <div class="row">
                        <q-icon name="mdi-reply-outline" size="sm" />
                        {{ $t('button.reply') }}
                    </div>
                </q-item-section>
            </q-item>

            <!-- Delete Message -->
            <!-- <q-item clickable v-close-popup @click="deleteMessage">
                <q-item-section>
                    <div class="row text-red">
                        <q-icon name="mdi-delete-outline" size="sm" />
                        {{ $t('buttons.delete') }}
                    </div>
                </q-item-section>
            </q-item> -->
        </q-list>
    </q-menu>
</template>

<style lang="scss" scoped></style>

<script lang="ts">
import { defineComponent } from 'vue';
import { Message } from 'src/services/models/Message';
import { MessageType } from 'src/services/enums/MessageType';
import { useStore } from 'src/store';
import { MessageDeleteFlag } from 'src/services/enums/MessageDeleteFlag';
import { debounce } from 'quasar';
// import { useQuasar } from 'quasar';
// import moment from 'moment';
// import DeleteMessageDialog from 'src/components/alerts/DeleteMessageDialog.vue';
// import ForwardDialog from 'src/components/alerts/ForwardDialog.vue';
// import { User } from 'src/services/models/User';

export default defineComponent({
    name: 'MessageContextMenu',
    props: {
        message: {
            type: Object as () => Message,
            required: true
        }
    },
    setup(props) {
        const store = useStore();
        const replyTo = () => {
            store.dispatch('chat/setReply', props.message);
        };

        // const updateFavouriteFlag = (value: 0 | 1) => {
        //     store.dispatch('message/favouriteFlag', {
        //         messageIds: [props.message.id],
        //         value
        //     });
        // };

        // const $q = useQuasar();
        // const user = computed((): User => store.state.user.user as User);

        // const selectMultiple = () => {
        //     store.dispatch('chat/setIsSelectMultiple', true);
        // };

        // const forward = () => {
        //     $q.dialog({
        //         component: ForwardDialog,
        //         componentProps: {
        //             messageIds: [props.message.id]
        //         }
        //     });
        // };

        // const canDeleteAll = () => {
        //     return (
        //         (moment(props.message.createdAt)
        //             .add(10, 'minutes')
        //             .isAfter(moment()) ??
        //             false) &&
        //         props.message.flags?.deleteFlag !=
        //             MessageDeleteFlag.DELETE_ALL &&
        //         (props.message.user?.id ?? props.message.userId) ==
        //             user.value.id
        //     );
        // };

        // const deleteMessage = () => {
        //     $q.dialog({
        //         component: DeleteMessageDialog,
        //         componentProps: {
        //             messageIds: [props.message.id],
        //             hideDeleteAll: canDeleteAll()
        //         }
        //     });
        // };

        return {
            MessageType,
            MessageDeleteFlag,
            replyTo: debounce(replyTo, 1000, true)
            // updateFavouriteFlag: debounce(updateFavouriteFlag, 1000, true),
            // forward: debounce(forward, 1000, true),
            // deleteMessage: debounce(deleteMessage, 1000, true),
            // selectMultiple: debounce(selectMultiple, 1000, true),
        };
    }
});
</script>
